# amp-async-function
[![npm version](https://img.shields.io/npm/v/amp-async-function.svg)](https://www.npmjs.com/package/amp-async-function)
[![Package Quality](http://npm.packagequality.com/shield/amp-async-function.svg)](http://packagequality.com/#?package=amp-async-function)
[![Build Status](https://travis-ci.org/allansli/amp-async-function.svg?branch=develop)](https://travis-ci.org/allansli/amp-async-function)
[![Coverage Status](https://coveralls.io/repos/github/allansli/amp-async-function/badge.svg?branch=master)](https://coveralls.io/github/allansli/amp-async-function?branch=master)
[![NPM Downloads](https://img.shields.io/npm/dt/amp-async-function.svg)](https://www.npmjs.com/package/amp-async-function)
[![dependencies](https://david-dm.org/allansli/amp-async-function/status.svg)](https://david-dm.org/allansli/amp-async-function)
[![devDependencies](https://david-dm.org/allansli/amp-async-function/dev-status.svg)](https://david-dm.org/allansli/amp-async-function)

Angular async function executor ES5 friendly.

## Demo
Check out [here](http://htmlpreview.github.io/?https://github.com/allansli/amp-async-function/blob/master/demo/index_git.html).

## Usage

Install **amp-async-function** using **npm**.
```js 
npm install amp-async-function --save
```

Include module **amp-async-function** into your app.
```js
angular.module("my.app", ["amp-async-function"]);
```

Guide:

 * Inject the factory: `asyncFunction`;
 * Call your function: `asyncFunction.execute(yourFunction, [] /*array of params*/, 0 /*delay*/);`


Use the factory as example below:
```js
    angular
        .module("async-func-demo")
        .controller("AsyncFuncController", AsyncFuncController);


    function AsyncFuncController(asyncFunction) {
        var vm = this;
        vm.exec = function () {
            asyncFunction.execute(vm.asyncFunc, [1], 10)
                .then(function (data) {
                // function resolved
                });
        }

        vm.asyncFunc = function (id) {
            return id;
        }
    }
```

## Support on Beerpay
Hey dude! Help me out for a couple of :beers:!

[![Beerpay](https://beerpay.io/allansli/amp-async-function/badge.svg?style=beer-square)](https://beerpay.io/allansli/amp-async-function)  [![Beerpay](https://beerpay.io/allansli/amp-async-function/make-wish.svg?style=flat-square)](https://beerpay.io/allansli/amp-async-function?focus=wish)
