var gulp = require("gulp");
var concat = require("gulp-concat");
var jshint = require("gulp-jshint");
var uglify = require("gulp-uglify");
var del = require("del");
var cssmin = require("gulp-cssmin");
var Server = require("karma").Server;


gulp.task("test", function (done) {
  new Server({
    configFile: __dirname + "/karma.conf.js",
    singleRun: true
  }, done).start();
});

gulp.task("lint", function () {
    return gulp.src(["src/*.js", "!node_modules/**"])
        .pipe(jshint())
        .pipe(jshint.reporter("default"))
        .pipe(jshint.reporter("fail"));
});

gulp.task("deploy",
    ["build", "remove-dist-dir", "copy-files"]
    , function () { }
);

gulp.task("remove-dist-dir", function () {
    del.sync("dist/**");
});

gulp.task("concat-js-files", function () {
    return gulp.src(["./src/amp-async-function.module.js"
        , "./src/amp-async-function.factory.js"])
        .pipe(concat("amp-async-function.min.js"))
        //.pipe(uglify())
        .pipe(gulp.dest("./dist/"));
});


gulp.task("copy-files", ["concat-js-files"], function () {

});

gulp.task("build", ["lint", "test"], function () {

});

gulp.task("default", ["deploy"], function () {

});